Subject: Re: bug#31994: Support for WinRe partition

From: "Brian C. Lane" <[email-masked]>
Date: Thu, 19 Jul 2018 15:33:21 -0700

On Thu, Jun 28, 2018 at 10:36:45AM +0000, Hans-Joachim Baader wrote:
> Hello maintainers,
> 
> Windows 10 uses a recovery partition which is sometimes marked with
> partition type 0x27 on MBR systems. I don't know why some vendors
> use MBR rather than GPT, but it's a fact.
> 
> 0x27 is in fact defined as Windows RE hidden partition (see
> https://www.win.tue.nl/~aeb/partitions/partition_types-1.html).
> 
> I haven't found a way to create a partition with this ID in parted. I used
> parted 3.2 which is 4 years old but I don't think is has been changed
> in Git. For example when I create a NTFS partition and do
> 
> set 3 hidden on
> 
> I get ID 0x17. Perhaps a new flag is needed, e.g.
> 
> set 3 winre on
> 
> Do you think that parted should support that? Perhaps I could contribute
> a patch if it's not supported yet.

It looks like we know about it internally, PARTITION_MSFT_RECOVERY, but
it isn't hooked up to a flag type. It is displayed as diag, but using
diag sets it to 0x12 (COMPAQ_DIAG).

It would probably be a good thing to separate that out. We already have
a msftres that's only used on GPT so I think it makes sense to hook that
command up to 0x27 on MBR. That also means no changes to the list of
PED_PARTITION_* flags.

If you'd like to try patching it that would be great, thanks!

-- 
Brian C. Lane (PST8PDT)